//
// AboutCommand.cs
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Aug 18, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

using System;
using System.Reflection;
using Gtk;
using Pcw.PcwTextEditor.ExtensionModel;
using Pcw.PcwTextEditor.PcwDocument;

namespace Pcw.PcwTextEditor.Commands
{
	/// <summary>
	/// Display about dialog
	/// </summary>
	class AboutCommand : ICommand
	{	
		private string id = "";
		
		public string Id
		{
			set {id = value;}
			get{return id;}
		}
		
		public MenuItem MenuObject {set {;} }
		
		public ToolItem ToolObject {set {;} }
		
		private string license = 
			@"The MIT License

Copyright (C) 2011 Fredy Ramirez - http://www.pacificcoolwave.com

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the 'Software'), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.";
		
		public void Run ()
		{
			
			AboutDialog dialog = new AboutDialog();
			
			Assembly asm = Assembly.GetExecutingAssembly ();
		
			dialog.ProgramName = (asm.GetCustomAttributes (typeof (AssemblyTitleAttribute), false) [0] as AssemblyTitleAttribute).Title;
		
			dialog.Version = asm.GetName ().Version.ToString ();
		
			dialog.Comments = (asm.GetCustomAttributes (typeof (AssemblyDescriptionAttribute), false) [0] 
			                   as AssemblyDescriptionAttribute).Description;
		
			dialog.Copyright = (asm.GetCustomAttributes (typeof (AssemblyCopyrightAttribute), false) [0] as AssemblyCopyrightAttribute).Copyright;
		
			dialog.License = license;
			dialog.Website = "http://www.pacificcoolwave.com";
		
			//dialog.Authors = authors;
			
			dialog.Run ();
			dialog.Destroy();
			
		}
		
		public void OnLoadDocument ()
		{
		}

		public void OnSaveDocument ()
		{
		}

		public void OnCreateDocument ()
		{
		}
		
		public void OnCloseDocument ()
		{
		}

		public void OnChangeDocument ()
		{
		}
		
		public void OnSelectDocument ()
		{
		}
	}
}