//
// IDocumentState.cs
//  DocumentState interface
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Aug 11, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

using System;
using Gtk;
using Mono.Addins;

namespace Pcw.PcwTextEditor.PcwDocument
{
	public interface IDocumentState
	{
		/// <summary>
		/// Called when a document is loaded
		/// </summary>
		void OnLoadDocument ();

		/// <summary>
		/// Called when a document is saved
		/// </summary>
		void OnSaveDocument ();

		/// <summary>
		/// Called when a new document is created
		/// </summary>
		void OnCreateDocument ();
		
		/// <summary>
		/// Called when a document is closed
		/// </summary>
		void OnCloseDocument ();

		/// <summary>
		/// Called when a document changed
		/// </summary>
		void OnChangeDocument ();
		
		/// <summary>
		/// Called when a document is selected
		/// </summary>
		void OnSelectDocument ();
	}
}

