//
// IDocumentType.cs
//  Gtk Window
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Sep 16, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

using System;
using System.Collections.Generic;
using Gtk;

namespace Pcw.PcwTextEditor.PcwDocument
{
	/// <summary>
	/// Used for Document implementation
	/// </summary>
	/// <remarks>
	/// All documents have to implements this interface and their functionality.
	/// i.e. FileDocument and DirectText
	/// </remarks>
	public interface IDocumentType
	{
		event DocumentTypeEventHandler DocumentTypeCreate;
		event DocumentTypeEventHandler DocumentTypeClose;
		event DocumentTypeEventHandler DocumentTypeSave;
		event DocumentTypeEventHandler DocumentTypeLoad;
		
		bool IsNew {get;}
		bool Saved {get; set;}
		string Name {get;}
		string Extension {get;}
		string NameWithExtension {get;}
		string Path {get;}
		string NameWithPath {get; set;}
		TextBuffer Buffer {set;}
		Dictionary<string, object> Data {get;}
		string Text {get;}
		
		bool Open();
		bool Save();
		bool Close();
		
	}
}

