//
// Program.cs
//
// Author: 
//  Fredy Ramirez (framirez@pacificcoolwave.com)
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Aug 9, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE  SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* prueba 2 */

using System;
using System.Reflection;
using System.Collections.Generic;
using Pcw.PcwTextEditor;
using Mono.Unix;

namespace Pcw.RunTextEditor
{
	public static class Program
	{
		[STAThread]
		static void Main (string[] args)
		{
			//Pcw.PcwNantFunctions.PcwNantFunctions p = new  Pcw.PcwNantFunctions.PcwNantFunctions(null, null);	
			
			Catalog.Init("TextEditor","./locale");
			
		 	TextEditor editor = new TextEditor();
			
			List <string> files = new List<string>();
			string rcFile = "";
			
			foreach(string s in args)
			{
				switch (s)
				{
					case "/l":
					case "-l":
						WriteLicense();
						return;
					case "/?":
					case "-?":
					case "/help":
					case "-help":
						WriteHelp();
						return;
					case "/rc":
					case "-rc":
						rcFile = GetRcFile(s);
						break;
					default:						
						files.Add(s);
						break;
				}
			}
			
			editor.Open(files, rcFile);
			
		}
		
		private static void WriteHelp()
		{
			Console.WriteLine(string.Format("PcwTextEditor Version {0}, Copyright (C) 2011 Fredy Ramirez - www.pacificcoolwave.com",
							Assembly.GetExecutingAssembly().GetName().Version.ToString()));			
			Console.WriteLine("");			
			Console.WriteLine(Catalog.GetString("Runs PcwTextEditor and open an especified list of files."));
			Console.WriteLine("");
			Console.WriteLine(Catalog.GetString("Usage:"));
			Console.WriteLine("   TextEditor.exe [OPTION...] [FILE1, FILE2, FILEn]");
			Console.WriteLine("");
			Console.WriteLine(Catalog.GetString("Options:"));
			Console.WriteLine(Catalog.GetString("{0} Sets RC application file"), "   /rc:[rcFileName]");
			Console.WriteLine(Catalog.GetString("{0} outputs the license and warranty"), "   /l");
			Console.WriteLine(Catalog.GetString("{0} outputs this text"), "   /?");
			Console.WriteLine("");
		}		
		
		private static void WriteLicense()
		{
			Console.WriteLine("");
			Console.WriteLine(string.Format("PcwTextEditor Version {0}, Copyright (C) 2011 Fredy Ramirez - www.pacificcoolwave.com",
							Assembly.GetExecutingAssembly().GetName().Version.ToString()));
			Console.WriteLine("-- MIT License --");
			Console.WriteLine(Catalog.GetString("{0} comes with ABSOLUTELY NO WARRANTY.  This is free software."), "PcwTextEditor");
			Console.WriteLine(Catalog.GetString("You are welcome to redistribute it under certain conditions."));
			Console.WriteLine("");
			Console.WriteLine(Catalog.GetString("For help, type {0}"), "TextEditor.exe /?");
			Console.WriteLine("");
		}
		
		private static string GetRcFile(string arg)
		{
			return arg.Substring(arg.IndexOf(":" + 1));
		}
	}
}
