//
// FindTextAddin.cs
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Sep 30, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

using System;
using Pcw.PcwTextEditor;
using Pcw.PcwTextEditor.ExtensionModel;

//[assembly: Addin ("Pcw.FindText","1.0", Namespace="PcwTextEditor")]
//[assembly: AddinDependency ("Core", "1.0")]

namespace Pcw.Addins.Search
{
	//[Extension]
	public class FindTextAddin : EditorExtension
	{
		private static FindText find;
		private static GotoLine go_line;
		
		public static FindText Find {
			get {
				return find;
			}
		}
		
		public static GotoLine GoLine {
			get {
				return go_line;
			}
		}		
		
		public override void Initialize ()
		{
			find = new FindText("yellow");
			go_line = new GotoLine();
		}
		
		public override void OnSelectDocument ()
		{
			find.Buffer = TextEditor.MainWin.CurrDocument.ViewText.Buffer;
			go_line.Buffer = TextEditor.MainWin.CurrDocument.ViewText.Buffer;
		}
		
		public override void OnCloseDocument ()
		{
			if (TextEditor.MainWin.Documents.Count > 0)
				return;	
			find.CloseFind();
			go_line.CloseGotoLine();
		}
	}
}
