//
// GotoLineGui.cs
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Oct 4, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */


using System;
using Gtk;
using Mono.Addins;

namespace Pcw.Addins.Search
{
	public class GotoLineGui : Window
	{
		private GotoLine go_line;
		private static bool shown = false;
		
		private Entry ent_go;
	
		internal static bool IsShown {
			get {
				return shown;
			}
		}		
		
		internal GotoLineGui (GotoLine goLine, Window parent) : base("")
		{
			go_line = goLine;
			
			Title = AddinManager.CurrentLocalizer.GetString ("Goto line");
			BorderWidth = 10;
			Modal = false;
			TransientFor = parent;
			SkipPagerHint = true;
			SkipTaskbarHint = true;
			WindowPosition = WindowPosition.Center;
			Resizable = false;
			AllowGrow = false;
			DestroyWithParent = true;
			
			// TODO Set Opacity in config file
			// Opacity = 0.9; // Vulues 0.1 to 1.0
						
			DeleteEvent += delegate(object o, DeleteEventArgs args) {
				CloseWindow();
			};
			
			VBox vb = new VBox(false, 10);
			
			vb.PackStart(BuildLabelEntryBox(),false,false,0);
			vb.PackStart(BuildButtonBox(),false,false,0);
			
			Add(vb);
			ShowAll();
			
			shown = true;
		}
		
		internal void Close ()
		{
			CloseWindow();
		}		
		
		private Table BuildLabelEntryBox()
		{
			Table tb = new Table(1,1, false);
			tb.BorderWidth = 10;
			tb.ColumnSpacing = 10;
			tb.RowSpacing = 10;
			
			ent_go = new Entry();
			
			tb.Attach(new Label (AddinManager.CurrentLocalizer.GetString ("Goto line") + ":"), 0, 1, 0 , 1);
			tb.Attach(ent_go, 1, 2, 0, 1);
			
			return tb;
		}
		
		private HBox BuildButtonBox()
		{
			HBox hb = new HBox(false,10);
			
			hb.PackEnd(BuildButton("Goto", AddinManager.CurrentLocalizer.GetString("Go")),false,false,0);
			hb.PackEnd(BuildButton("Close", AddinManager.CurrentLocalizer.GetString("Close")),false,false,0);
			
			return hb;
		}		
		
		private Button BuildButton(string name, string label)
		{
			Button btn = new Button(label);
			btn.Name = name;
			btn.Clicked += btn_clicked;
			
			return btn;
		}		
		
		private void btn_clicked( object obj, EventArgs args)
		{
			Button btn = (Button) obj;
			
			switch(btn.Name) 
			{
				case "Goto":
					go_line.GoLine(ent_go.Text);
					break;	
				
				case "Close":
					CloseWindow();
					break;
			}
		}		
		
		private void CloseWindow()
		{
			shown = false;
			Destroy();
		}		
	}
}

