//
// Separators.cs
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Dec 12, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

using System;
using System.Xml;
using System.Text.RegularExpressions;

namespace Pcw.Addins.Highlighting.Definition
{
	internal class Separators
	{
		private Regex regex;
		
		internal Separators (XmlNode node)
		{			
			string regexString = "";
			
			foreach (XmlNode n in node.ChildNodes) 
			{
				XmlElement item = (XmlElement)n;				
				regexString = regexString + "(" + Regex.Escape (XmlUtil.GetString(item, "value")) + ")|";
			}
			
			if (regexString != "") {
				if (regexString.EndsWith("|"))
					regexString = regexString.Substring(0, regexString.Length - 1);
			
				//Console.WriteLine("Separators regexString: {0}", regexString);
				
				regex = GetRegexObject(regexString, true);
				
			}
		}
		
		internal bool IsMatch (string text)
		{
			if (regex == null)
				return false;
			
			return regex.IsMatch(text);
		}
		
		private Regex GetRegexObject(string stringPattern, bool caseSensitive)
		{
			RegexOptions options = new RegexOptions();
			options |= RegexOptions.Singleline;
			options |= RegexOptions.Multiline;
			if (!caseSensitive) options |= RegexOptions.IgnoreCase;
			
			regex = new Regex(stringPattern, options);

			return regex;
		}
	}
}

















