//
// XmlUtil.cs
//
// Author: 
//  Fredy Ramirez <framirez@pacificcoolwave.com>
//
// Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)
//
//  Creation date: Oct 13, 2011
//  Last modification: 

/*
The MIT License

Copyright (C) 2011 Fredy Ramirez (http://www.pacificcoolwave.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */


using System;
using System.Xml;
using System.Text.RegularExpressions;

namespace Pcw.Addins.Highlighting.Definition
{
	internal class XmlUtil
	{
		internal XmlUtil ()
		{
		}
		
		internal static bool GetBoolean(XmlElement element, string attrName)
		{
			if (element.HasAttribute(attrName))				
				try 
				{
					return Convert.ToBoolean (element.Attributes[attrName].Value);
				}
				catch 
				{
					return false;
				}			
			
			else
				return false;
		}
		
		internal static string GetString(XmlElement element, string attrName)
		{
			if (element.HasAttribute(attrName))
				return element.Attributes[attrName].Value;
			else
				return "";
		}
				
		internal static HighlightType GetHighlightType(string hlType)
		{
			switch(hlType.Trim().ToLower())
			{
				case "wholeword":
					return HighlightType.WholeWord;
				case "contains":
					return HighlightType.Contains;				
				case "toclosetoken":
					return HighlightType.ToCloseToken;
				case "toeol":
					return HighlightType.ToEOL;
				default:
					throw new ArgumentException("Unknown HighlightType: '" + hlType + "'");				
				
				/*
				case "word":
					return HighlightType.Word;
				case "toclosetoken":
					return HighlightType.ToCloseToken;
				case "toeol":
					return HighlightType.ToEOL;
				default:
					throw new ArgumentException("Unknown HighlightType: '" + hlType + "'");				
				*/
			}
		}
		
		/*
		internal static HighlightRecognition GetHighlightHighlightRecognition(string hlRecognition)
		{
			switch(hlRecognition.Trim().ToLower())
			{
				case "wholeword":
					return HighlightRecognition.WholeWord;
				case "startswith":
					return HighlightRecognition.StartsWith;
				case "contains":
					return HighlightRecognition.Contains;
				default:
					throw new ArgumentException("Unknown HighlightRecognition: '" + hlRecognition + "'");
			}
		}	
		*/
	}
}

