using System;
using Gtk;
using Pcw.Addins.Search;

namespace FindTextGuiTest
{
	public class FindTextGui : Window
	{
		private TextBuffer buffer;
		private FindText find;
		private GotoLine go_line;
		
		public static void Main ()
		{			
			Application.Init ();
			new FindTextGui ();
			Application.Run ();
		}
		
		public FindTextGui () : base("Find and Replace test")
		{
			// Create a Window
			SetSizeRequest (250,250);
			DeleteEvent += delete_event;
			BorderWidth = 10;
			
			VBox vb = new VBox(false,0);
			
			Button btn = new Button("Find");
			btn.Clicked += btn_clicked;
			vb.PackStart(btn, false, false, 0);

			Button btnR = new Button("Replace");
			btnR.Clicked += btnR_clicked;
			vb.PackStart(btnR, false, false, 0);

			Button btnGo = new Button("Goto Line");
			btnGo.Clicked += btnGoto_clicked;
			vb.PackStart(btnGo, false, false, 0);			
			
			TextTagTable tb = new TextTagTable();
			buffer = new TextBuffer(tb);
			TextView tw = new TextView(buffer);
			vb.PackStart(tw, true, true, 0);
			
			find = new FindText(buffer, "yellow");
			go_line = new GotoLine(buffer);
			
			Add(vb);
	 			
			ShowAll ();
			
		}		
		
		private void delete_event (object obj, DeleteEventArgs args)
		{
			Application.Quit();
		}
		
		private void btn_clicked( object obj, EventArgs args)
		{	
			find.ShowFind(this, false);
		}
		
		private void btnR_clicked( object obj, EventArgs args)
		{
			find.ShowFind(this, true);
		}
		
		private void btnGoto_clicked( object obj, EventArgs args)
		{	
			go_line.ShowGotoLine(this);
		}		
	}
}

